Page MenuHomePhabricator

Speech Synthesis support
Closed, ResolvedPublic

Description

It looks like feature requests are being made here, so if all right, I'd like to request Speech Synthesis support be added to allow a user to have an article or a portion thereof be spoken to them. It's not universal across browsers, but Chrome, Safari, and Opera currently support it. Firefox apparently has some infrastructure for it started, but it is not yet working there. Microsoft is supposedly considering support: http://caniuse.com/#search=speech

I've implemented some code at http://bahai.works (see http://bahai.works/The_Hidden_Words/Arabic for one sample). Though the JavaScript code (about the first 1/4 of http://bahai.works/index.php?title=MediaWiki:Common.js and also stored now at https://github.com/brettz9/mw-speechsynth ) could be cleaned up a bit and be put in a library form, it is working fine, and should work fine on other sites as well.

You can either push play to start from the beginning of the page text or highlight a block of text to have that text spoken. It currently has some code to ignore certain elements by ID or class (as those are used by templates on the site to indicate text, such as paragraph numbers or headers, which should not be read out loud).

Event Timeline

Brettz9 created this task.Jul 21 2015, 3:52 AM
Brettz9 raised the priority of this task from to Needs Triage.
Brettz9 updated the task description. (Show Details)
Brettz9 added a subscriber: Brettz9.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 21 2015, 3:52 AM
Brettz9 updated the task description. (Show Details)Jul 21 2015, 5:58 AM
Brettz9 set Security to None.

Might be something to turn into a new extension rather than part of MediaWiki core.

Aklapper triaged this task as Lowest priority.Jul 22 2015, 4:40 PM
SamanthaNguyen closed this task as Resolved.Mar 14 2017, 5:52 PM
SamanthaNguyen claimed this task.
SamanthaNguyen added a subscriber: SamanthaNguyen.

Going to be bold and mark this as resolved since I believe this is now available as a Wikimedia project called Wikispeech (with speech synthesis handled in the module Wikispeech-Synthesis) , being currently developed by Wikimedia Sverige.